<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	Discount
* @contact 		shyam@readybytes.in
*/
if(defined('_JEXEC')===false) die();


/**
 * Virtue Mart System
 * @author Puneet
 */
class PayplansAppVirtueMart extends PayplansApp
{
	//inherited properties
	protected $_location	= __FILE__;
	
	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

		$newStatus  = $new->getStatus();
		
		$active = $this->getAppParam('addToShoppersGroupOnActive');
		
		$hold 	= $this->getAppParam('addToShoppersGroupOnHold');
		
		$expire = $this->getAppParam('addToShoppersGroupOnExpire');
			
		$userid = $new->getBuyer();
		 
		// #1 : remove from groups assigned from other status (if applicable)
		// #2 : add to group and add resource for current status 
		
		// if subscription is active
		if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
			$this->_removeFromShoppersGroup($userid, $hold);
			$this->_removeFromShoppersGroup($userid, $expire);
			$this->_addToShoppersGroup($userid, $active);
			
			return true;
		}
		
		if($newStatus == PayplansStatus::SUBSCRIPTION_HOLD){
			$this->_removeFromShoppersGroup($userid, $active);
			$this->_removeFromShoppersGroup($userid, $expire);
			$this->_addToShoppersGroup($userid, $hold);
			
			return true;
		}
		
		if($newStatus == PayplansStatus::SUBSCRIPTION_EXPIRED){
			$this->_removeFromShoppersGroup($userid, $active);
			$this->_removeFromShoppersGroup($userid, $hold);
			$this->_addToShoppersGroup($userid, $expire);
			
			return true;
		}
	
		return true;
	}


	protected function _addToShoppersGroup($userid, $groupid)
	{
		if(empty($groupid)){
			return true;
		}
		
		$shoppergroupid = $this->_getShopperGroup($userid);
		
		if($shoppergroupid == false || $shoppergroupid == null){
			$this->_insertShopperToGroup($userid, $groupid);
		}else 
		{
			$this->_removeFromResource($subid, $userid, $groupid, $this->_resource);
			$this->_updateShopperToGroup($userid, $groupid);
		}
		
		$this->_addToResource($subid, $userid, $groupid, $this->_resource);
		return true;
	}

	protected function _removeFromShoppersGroup($userid, $groupid)
	{
		if(empty($groupid)){
			return true;
		}
		
		$shoppergroupid = $this->_getShopperGroup($userid);
		
		if($shoppergroupid != false || $shoppergroupid != null)
		{
			$this->_removeFromResource($subid, $userid, $groupid, $this->_resource); 
			$this->_deleteShopperToGroup($userid);
			return true;
		}
	}
	
	protected function _getShopperGroup($userid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `virtuemart_shoppergroup_id`'
			. ' FROM #__virtuemart_vmuser_shoppergroups'
			. ' WHERE `virtuemart_user_id` = ' . $userid;
		$db->setQuery( $query );
		
		return $db->loadResult();
	}
	
	protected function _insertShopperToGroup($userid, $groupid)
	{
		$db = JFactory::getDBO();
		
		$query = 'INSERT INTO #__virtuemart_vmuser_shoppergroups (`virtuemart_user_id`, `virtuemart_shoppergroup_id`) VALUES ('
				. $userid . ','. implode(",",$groupid) . ')';
		
		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _updateShopperToGroup($userid, $groupid)
	{
		$db = JFactory::getDBO();
		$query = 'UPDATE #__virtuemart_vmuser_shoppergroups'
			. ' SET `virtuemart_shoppergroup_id` = \'' .  $groupid  . '\''
			. ' WHERE `virtuemart_user_id` = \'' . $userid . '\''
			;
		$db->setQuery( $query );
		return $db->query();
	}
	
	protected function _deleteShopperToGroup($userid)
	{
		$db = JFactory::getDBO();
		$query = 'DELETE FROM #__virtuemart_vmuser_shoppergroups'
			. ' WHERE `virtuemart_user_id` = \'' . $userid . '\''
			;
		$db->setQuery( $query );
		return $db->query();
	}
	
	public static function getShopperGroups()
	{
		$db = JFactory::getDBO();
		$query = 'SELECT virtuemart_shoppergroup_id, shopper_group_name'
			 	. ' FROM #__virtuemart_shoppergroups'
			 	;
	 	$db->setQuery( $query );
	 	return $db->loadObjectList('virtuemart_shoppergroup_id'); 
	}

	protected function _getUserShopperGroup($userid)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT `virtuemart_shoppergroup_id`'
			. ' FROM #__virtuemart_vmuser_shoppergroups'
			. ' WHERE `virtuemart_user_id` = ' . $userid;
		$db->setQuery( $query );
		
		$shopperGroupId = $db->loadResult();

		$query = 'SELECT `shopper_group_name` '
			. ' FROM #__virtuemart_shoppergroups '
			. ' WHERE `virtuemart_shoppergroup_id` = ' . $shopperGroupId;
			
		$db->setQuery( $query );
		$shopperGroup = $db->loadResult();
		
		return $shopperGroup;
	}
	
	//render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's shopper's groups
	    $shopper_group = $this->_getUserShopperGroup($userid);
	    if(empty($shopper_group)){
	    	return '';
	    }
	    $this->assign('shopper_group',$shopper_group);
        $data = $this->_render('widgethtml');
        return $data;
	}

}
